require 'store/query'

class Store
  class Repo
    def initialize(entity_classes, data_mapping, entity_mapping)
      @store = Store.new(entity_classes, data_mapping, entity_mapping)
    end

    def build(entity, *args)
      @store.build(entity, *args)
    end

    def save(entities)
      @store.save(entities)
      true
    end

    def reload(entity)
      @store.reload(entity)
    end

    def save_and_load(entities)
      refs = @store.save(entities)
      @store.load(refs)
    end

    def remove(entity)
      @store.remove(entity)
      true
    end

    private
    def query(query)
      @store.query(query)
    end

    def reference(entity)
      @store.reference(entity)
    end
  end
end
