require 'store/resolver/entity_mapper'
require 'store/resolver/data_mapper'

module Resolver

  def extract_entity_class_name(obj)
    if obj.kind_of? Store::Ref
      extract_entity_class_name_from_ref(obj)
    elsif obj.kind_of? Store::Query
      extract_entity_class_name_from_query(obj)
    else
      extract_entity_class_name_from_object(obj)
    end
  end

  def extract_entity_class_name_from_ref(ref)
    ref.entity_type
  end

  def extract_entity_class_name_from_query(query)
    query.entity
  end

  def extract_entity_class_name_from_object(obj)
    obj.class.name.split('::').last
  end

end
